<?php

class BorrowBookController extends Controller {
    public function record(Request $request) {
        $data = $request->getBody();
        $data['borrow_date'] = date('Y-m-d');
        $data['return_date'] = date('Y-m-d', strtotime('+7 days')); // Assuming the return date is 7 days from now
        $data['amount'] = 15; // Assuming the book is free to borrow
        $data['late_fine'] = 0; // Assuming the user returns the book on time
        $data['transaction_type'] = "waiting";
        $data['transaction_date'] = date('Y-m-d');
        $data['quantity'] = 1; // Assuming the user borrows only one copy of the book
        $data['created_at'] = date('Y-m-d');
        $data['updated_at'] = date('Y-m-d');
        $transaction_model = $this->model('TransactionModel');
        $transaction_model->createTransaction($data);

    }

 public function index(){
  // Get current page number
  $page = isset($_GET['page']) ? intval($_GET['page']) : 1;
  $searchQuery = isset($_GET['search']) ? trim($_GET['search']) : '';
  $model = $this->model('TransactionModel');
  $params['borrow_books'] = $model->getTransactionData($page, 10, $searchQuery);

  $totalRecords = $model->countTransactions();
  $pagination = new Pagination($totalRecords, $page, 10);
  if ($totalRecords > $pagination->getLimit()) {
    $params['pagination'] =  $pagination->render();
    } else {
        $params['pagination'] = '';
    }

  $this->view('borrow-books', $params);

        
    }



}

