<?php
class IssueRequestController extends Controller{
    public function index(){

        $page = isset($_GET['page']) ? intval($_GET['page']) : 1;
        $searchQuery = isset($_GET['search']) ? trim($_GET['search']) : '';
        $model = $this->model('IssueRequestModel');
        $params['issue-request'] = $model->getIssueData($page, 10, $searchQuery);

        $totalRecords = $model->countIssue();
        $pagination = new Pagination($totalRecords, $page, 10);

        $params['countIssueRequest'] = $model->countIssueRequest();

        if ($totalRecords > $pagination->getLimit()) {
            $params['pagination'] =  $pagination->render();
            } else {
                $params['pagination'] = '';
            }

        $this->view('issue-request',$params);
    }

    public function record(Request $request) {
        // Sample associative array with data
        $data = $request->getBody();
        $data['transaction_date'] = date('Y-m-d');
        $data['amount'] = 15; // Assuming the book is free to borrow
        $data['late_fine'] = 0; // Assuming the user returns the book on time
        $data['quantity'] = 1; // Assuming the user borrows only one copy of the book
        $data['created_at'] = date('Y-m-d');
        $data['updated_at'] = date('Y-m-d');
        $transaction_model = $this->model('IssueRequestModel');
        $transaction_model->createTransactionDetails($data);

    }

    public function listSentRequest(){

        $page = isset($_GET['page']) ? intval($_GET['page']) : 1;
        $searchQuery = isset($_GET['search']) ? trim($_GET['search']) : '';
        $model = $this->model('IssueRequestModel');
        $params['request-sent'] = $model->userIssueData($page, 10, $searchQuery);

        $totalRecords = $model->countUserIssue();
        $pagination = new Pagination($totalRecords, $page, 10);
        if ($totalRecords > $pagination->getLimit()) {
            $params['pagination'] =  $pagination->render();
            } else {
                $params['pagination'] = '';
            }


        $this->view('request-sent',$params);
    }

    public function viewReceipt(Request $request,$id){
         $model = $this->model('IssueRequestModel');
         $params['receipt'] = $model->userReceipt($id);
         $this->view('view-receipt',$params);
    }

}