<?php
class usersController extends Controller
{
    public function usersIndex()
    {
        $search = isset($_GET['search']) ? $_GET['search'] : '';
        $usersModel = $this->model('usersModel');
        	$searchColumns = array (
  0 => 'id',
  1 => 'first_name',
  2 => 'last_name',
  3 => 'email',
  4 => 'address',
  5 => 'contact_no',
  6 => 'password',
  7 => 'status',
  8 => 'role_id',

);
        $totalRecords = $usersModel->countAll($search, $searchColumns);
        $page = isset($_GET['page']) ? (int)$_GET['page'] : 1;
        $pagination = new Pagination($totalRecords, $page, 10);
        $data = $usersModel->displayAllSearch($search, $searchColumns, $pagination->getOffset(), $pagination->getLimit());
        $params['users'] = $data;
        if ($totalRecords > $pagination->getLimit()) {
            $params['pagination'] =  $pagination->render();
        } else {
            $params['pagination'] = '';
        }
        $this->view('users/usersAll', $params);
    }


    public function usersbuild()
    {
        $this->view('users/usersNew');
    }

    public function usersRecord(Request $request)
    {
        $usersModel = $this->model('usersModel');
        $data = $request->getBody();
        	$rules = array (
  'first_name' => 'required',
  'last_name' => 'required',
  'email' => 'required',
  'address' => 'required',
  'contact_no' => 'required',
  'password' => 'required',
  'status' => 'required',
  'role_id' => 'required',

);
        $validator = new Validator();
        $validator->validate($rules);
        if ($validator->fails()) {
            $errors = $validator->errors();
            foreach ($errors as $error) {
                echo $error . "</br>";
            }
        } else {
            $usersModel->record($data);
            return "Success";
        }
    }

    public function usersModify(Request $request,$id)
    {
        $usersModel = $this->model('usersModel');
        $params['userIdentify'] = $id;
        $params['users'] =  $usersModel->displaySingle($id);
        $this->view('users/usersEdit', $params);
    }

    public function usersEdit(Request $request, $id)
    {
        $usersModel = $this->model('usersModel');
        $data = $request->getBody();
        	$rules = array (
  'first_name' => 'required',
  'last_name' => 'required',
  'email' => 'required',
  'address' => 'required',
  'contact_no' => 'required',
  'password' => 'required',
  'status' => 'required',
  'role_id' => 'required',
);
        $validator = new Validator();

        if ($validator->fails($rules)) {
            $errors = $validator->errors();
            foreach ($errors as $error) {
                echo $error . "</br>";
            }
        } else {
            $usersModel->update($data, $id);
            return "Success";
        }
    }
}
