<?php
class booksController extends Controller
{
    public function booksIndex()
    {
        $search = isset($_GET['search']) ? $_GET['search'] : '';
        $booksModel = $this->model('booksModel');
        $searchColumns = array(
            0 => 'id',
            1 => 'title',
            2 => 'author',
            3 => 'quantity',
            4 => 'bookUpdated',
            5 => 'bookIdentify',
        );
        $totalRecords = $booksModel->countAll($search, $searchColumns);
        $page = isset($_GET['page']) ? (int)$_GET['page'] : 1;
        $pagination = new Pagination($totalRecords, $page, 10);
        $data = $booksModel->displayAllSearch($search, $searchColumns, $pagination->getOffset(), $pagination->getLimit());
        $params['books'] = $data;
        if ($totalRecords > $pagination->getLimit()) {
            $params['pagination'] =  $pagination->render();
        } else {
            $params['pagination'] = '';
        }
        $this->view('books/booksAll', $params);
    }

    public function booksDisplay(Request $request, $booksIdentify)
    {
        $booksModel = $this->model('booksModel');
        $params['books'] =  $booksModel->displaySingle($booksIdentify);
        $this->view('books/booksSingle', $params);
    }

    public function booksDestroy(Request $request, $booksIdentify)
    {
        $booksModel = $this->model('booksModel');
        $booksModel->erase($booksIdentify);
        echo "success";
    }

    public function booksbuild()
    {
        $this->view('books/booksNew');
    }

    public function booksRecord(Request $request)
    {
        $booksModel = $this->model('booksModel');
        $data = $request->getBody();
        $data['bookUpdated'] = date('Y-m-d H:i:s');
        $data['bookIdentify'] = generateUniqueId(16);
        $rules = array(
            'title' => 'required|max:255',
            'author' => 'required|max:100',
            'quantity' => 'required|max:11',
        );
        $validator = new Validator();
        $validator->validate($rules);
        if ($validator->fails()) {
            $errors = $validator->errors();
            foreach ($errors as $error) {
                echo $error . "</br>";
            }
        } else {
            $booksModel->record($data);
            return "Success";
        }
    }

    public function booksModify(Request $request, $booksIdentify)
    {
        $booksModel = $this->model('booksModel');
        $params['bookIdentify'] = $booksIdentify;
        $params['books'] =  $booksModel->displaySingle($booksIdentify);
        $this->view('books/booksEdit', $params);
    }

    public function booksEdit(Request $request, $booksIdentify)
    {
        $booksModel = $this->model('booksModel');
        $data = $request->getBody();
        $rules = array(
            'title' => 'required|max:255',
            'author' => 'required|max:100',
            'quantity' => 'required|max:11',
            'bookUpdated' => '',
            'bookIdentify' => 'required',
        );
        $validator = new Validator();

        if ($validator->fails($rules)) {
            $errors = $validator->errors();
            foreach ($errors as $error) {
                echo $error . "</br>";
            }
        } else {
            $booksModel->update($data, $booksIdentify);
            return "Success";
        }
    }
}
