<?php
class AuthModel extends Model
{
    private $db;
    public function __construct()
    {
      $this->db = Database::getInstance()->getConnection();
    }


    public function login($data = []) {
        $email = $data['email'];
        $password = $data['password'];
        // Find the user by email
        $stmt = $this->db->prepare("SELECT * FROM td_user WHERE email=:email");
        $stmt->execute([':email' => $email]);
        $user = $stmt->fetch(PDO::FETCH_ASSOC);

        if (!$user) {
            echo "User not found";
        } 
        else {
            if ($password == $user['password']) {
                $_SESSION['id'] = $user['id'];
                $_SESSION['role_id'] = $user['role_id'];
                header("Location:".ROOT."/"); // Redirect to the homepage
                exit();            
            } else {
                echo "Enter correct email and passord!";
            }
        }
    }

    public function getUser($id){
        $stmt = $this->db->prepare("SELECT * FROM td_user WHERE id=:id");
        $stmt->execute([':id' => $id]);
        $user = $stmt->fetch(PDO::FETCH_ASSOC);
        return $user;
    }


    public function totalUsers(){
        $stmt = $this->db->prepare("SELECT COUNT(*) FROM td_user  where role_id=:role_id");
        $stmt->execute([':role_id'=>2]);
        $result = $stmt->fetch(PDO::FETCH_ASSOC);
        return $result['total'];
    }


    public function totalBooks(){
        $stmt = $this->db->prepare("SELECT COUNT(*) FROM books");
        $stmt->execute();
        $result = $stmt->fetchColumn();
        return $result;
    }

    public function totalBorrowedBooks(){
        $stmt = $this->db->prepare("SELECT COUNT(*) FROM td_transactions");
        $stmt->execute();
        $result = $stmt->fetchColumn();
        return $result;
    }

    public function countIssueRequest(){
        $sql = "SELECT COUNT(*) FROM transactions  WHERE transaction_type = 'waiting'";
        $count = $this->db->query($sql)->fetchColumn();
        return $count;
    }
    
    

    public function signup($data = []) {
        $email = $data['email'];
        $password = $data['password'];
        // Check if user already exists
        $stmt = $this->db->prepare("SELECT * FROM td_user WHERE email=:email");
        $stmt->execute([':email' => $email]);
        $user = $stmt->fetch(PDO::FETCH_ASSOC);
        if ($user) {
            echo "User already exists";
        } else {
            // Create a new user
         $stmt = $this->db->prepare("INSERT INTO td_user (email, password, role_id) VALUES (:email, :password, :role_id)");
            $stmt->execute([
                ':email' => $email,
                ':password' => $password,
                ':role_id' => 2 // Set the role_id to 1
            ]);
            
            header("Location:".ROOT."/login"); // Redirect to the login
        }
    }

       public function forgotPassword($data = []) {
        $email = $data['email'];
        // Find the user by email
        $stmt = $this->db->prepare("SELECT * FROM users WHERE email=:email");
        $stmt->execute([':email' => $email]);
        $user = $stmt->fetch(PDO::FETCH_ASSOC);
        if (!$user) {
            return "User not found";
        } else {
            // Generate a new password
            $newPassword = bin2hex(random_bytes(6));
            // Update the user's password
            $stmt = $this->db->prepare("UPDATE users SET password=:password WHERE id=:id");
            $stmt->execute([':password' => password_hash($newPassword, PASSWORD_DEFAULT), ':id' => $user['id']]);
            // Send the new password to the user via email
            // ... code to send email ...
            return "New password generated and sent to user";
        }
    }

    public function logout()
    {
        if (isset($_SESSION['id']) && isset($_SESSION['role_id'])) {
            unset($_SESSION['id']);
            unset($_SESSION['role_id']);
            header("Location: " . ROOT . "/login/");
            exit;
        }
    }
}
