<?php
class IssueRequestModel extends Model {
    private $db;
    public function __construct()
    {
      $this->db = Database::getInstance()->getConnection();
    }
    public function userReceipt($id){
        $sql = "SELECT t.*, u.first_name, u.last_name, u.email, u.address, u.status, u.role_id, b.title, b.author, b.quantity, b.cover
        FROM transactions t
        JOIN td_user u ON t.user_id = u.id
        JOIN td_book b ON t.book_id = b.id
        WHERE t.t_id = :id";
    
        $stmt = $this->db->prepare($sql);
        $stmt->execute(array(':id' => $id));
        $results = $stmt->fetchAll(PDO::FETCH_ASSOC);
    
        // Return books and pagination data as an array
        return $results;
    }
    


    public function getIssueData($page, $itemsPerPage, $searchQuery)
    {

        $sql = "SELECT t.*, u.first_name, u.last_name, u.email, u.address, u.status, u.role_id, b.title, b.author, b.quantity,b.cover
        FROM transactions t
        JOIN td_user u ON t.user_id = u.id
        JOIN td_book b ON t.book_id = b.id
        WHERE t.transaction_type = 'waiting'";

            if (!empty($searchQuery)) {
                $sql .= "AND b.title LIKE '%$searchQuery%' OR b.author LIKE '%$searchQuery%' ";
            }

            // Add pagination limit and offset
            $limit = $itemsPerPage;
            $offset = ($page - 1) * $itemsPerPage;
            $sql .= "ORDER BY t.transaction_date DESC LIMIT $limit OFFSET $offset";


        $results = $this->db->query($sql)->fetchAll(PDO::FETCH_ASSOC);
        // Return books and pagination data as an array
        return $results;
    }

    public function countIssue()
    {
        $sql = "SELECT COUNT(*) FROM transactions WHERE transaction_type = 'waiting'";
        $count = $this->db->query($sql)->fetchColumn();
        return $count;
    }

    public function countIssueRequest(){
        $sql = "SELECT COUNT(*) FROM transactions  WHERE transaction_type = 'waiting'";
        $count = $this->db->query($sql)->fetchColumn();
        return $count;
    }

    public function createTransactionDetails($data) {
       
        $data1 = array(
            ':transaction_id' => $data['transaction_id'],
            ':transaction_date' => $data['transaction_date'],
            ':amount' => $data['amount'],
            ':late_fine' => $data['late_fine'],
            ':transaction_type' => $data['transaction_type'],
            ':quantity' => $data['quantity'],
            ':created_at' => $data['created_at'],
            ':updated_at' => $data['updated_at']
        );

        $data2 = array(
            'transaction_type' => $data['transaction_type'],
            't_id' => $data['transaction_id']
        );

        if($data['transaction_type'] == 'approved'){
            // Update transaction status
            $sql = "INSERT INTO transactions_details (transaction_id, transaction_date, amount, late_fine, transaction_type, quantity, created_at, updated_at) 
            VALUES (:transaction_id, :transaction_date, :amount, :late_fine, :transaction_type, :quantity, :created_at, :updated_at)";
            $stmt =  $this->db->prepare($sql);
            $stmt->execute($data1);

            if (isset($data['book_id'])) {
                $id = [':id' => $data['book_id']];
                $sql = "SELECT `quantity` FROM `td_book` WHERE `id` = :id";
                $stmt = $this->db->prepare($sql);
                $stmt->execute($id);
                $book = $stmt->fetch(PDO::FETCH_ASSOC);
                $newQuantity = $book['quantity'] - 1;
                $sql = "UPDATE `td_book` SET `quantity` = :newQuantity WHERE `id` = :id";
                $stmt = $this->db->prepare($sql);
                $stmt->bindParam(':newQuantity', $newQuantity, PDO::PARAM_INT);
                $stmt->bindParam(':id', $id[':id'], PDO::PARAM_INT);
                $stmt->execute();
            }
            


        }



            // Sample associative array with data
            $sql2 = "UPDATE transactions SET transaction_type = :transaction_type WHERE t_id = :t_id";
            $stmt2 = $this->db->prepare($sql2);
            $stmt2->execute($data2);

    }
    public function countUserIssue()
    {
        $userId = intval($_SESSION['id']);
        $sql = "SELECT COUNT(*) FROM transactions  WHERE user_id = $userId";
        $count = $this->db->query($sql)->fetchColumn();
        return $count;
    }
    public function userIssueData($page, $itemsPerPage, $searchQuery)
    {

$userId = intval($_SESSION['id']);

$sql = "SELECT t.*, u.first_name, u.last_name, u.email, u.address, u.status, u.role_id, b.title, b.author, b.quantity , b.cover
        FROM transactions t
        JOIN td_user u ON t.user_id = u.id
        JOIN td_book b ON t.book_id = b.id
        WHERE t.user_id = $userId";
        $results = $this->db->query($sql)->fetchAll(PDO::FETCH_ASSOC);
        return $results;
    }
}