<?php
class OverdueBooksModel extends Model{
    private $db;
    public function __construct()
    {
      $this->db = Database::getInstance()->getConnection();
    }
    public function getOverDueData($page, $itemsPerPage, $searchQuery)
    {
        // Construct SQL query with search and pagination
        $currentDate = new DateTime();
        $currentDateString = $currentDate->format('Y-m-d');

        $sql = "SELECT 
        t.t_id, 
        t.book_id, 
        t.user_id, 
        t.borrow_date, 
        t.return_date, 
        t.amount, 
        t.late_fine, 
        t.transaction_type, 
        t.transaction_date, 
        t.quantity, 
        t.created_at, 
        t.updated_at, 
        b.id, 
        b.title, 
        b.author, 
        b.quantity, 
        b.bookUpdated, 
        b.bookIdentify 
    FROM 
        transactions t 
        INNER JOIN td_book b ON t.book_id = b.id 
    WHERE 
        t.return_date < CURDATE()
        AND t.transaction_type = 'approved'";
        if(isset($_SESSION['role_id']) && $_SESSION['role_id'] == 2){
            $sql .= "AND t.user_id = " . $_SESSION['id'] . " ";
        }

        if (!empty($searchQuery)) {
            $sql .= "AND b.title LIKE '%$searchQuery%' OR b.author LIKE '%$searchQuery%' ";
        }
        $limit = $itemsPerPage;
        $offset = ($page - 1) * $itemsPerPage;
        $sql .= "ORDER BY t.transaction_date DESC LIMIT $limit OFFSET $offset";
        $results = $this->db->query($sql)->fetchAll(PDO::FETCH_ASSOC);
        return $results;
    }

    public function countOverdueBook()
    {
        $sql = "SELECT COUNT(*) FROM transactions   WHERE  return_date < CURDATE() AND transaction_type = 'approved'";
        $count = $this->db->query($sql)->fetchColumn();
        return $count;
    }
}