<?php
class TransactionModel extends Model {
    private $db;
    public function __construct()
    {
      $this->db = Database::getInstance()->getConnection();
    }

    public function createTransaction($data) {
        $stmt = $this->db->prepare("
            INSERT INTO transactions (book_id, user_id, borrow_date, return_date, amount, quantity,transaction_type, transaction_date, created_at, updated_at)
            VALUES (:book_id, :user_id, :borrow_date, :return_date, :amount, :quantity,:transaction_type, :transaction_date, :created_at, :updated_at)
        ");
    
            $stmt->execute(array(
                ':book_id' => $data['book_id'],
                ':user_id' => $_SESSION['id'],
                ':borrow_date' => $data['borrow_date'],
                ':return_date' => $data['return_date'],
                ':amount' => $data['amount'],
                ':quantity' => $data['quantity'],
                ':transaction_type' => $data['transaction_type'],
                ':transaction_date' => $data['transaction_date'],
                ':created_at' => $data['created_at'],
                ':updated_at' => $data['updated_at']
            ));
        
    }



    public function getTransactionData($page, $itemsPerPage, $searchQuery)
    {
        // Construct SQL query with search and pagination
        $sql = "SELECT 
                    t.t_id, 
                    t.book_id, 
                    t.user_id, 
                    t.borrow_date, 
                    t.return_date, 
                    t.amount, 
                    t.late_fine, 
                    t.transaction_type, 
                    t.transaction_date, 
                    t.quantity, 
                    t.created_at, 
                    t.updated_at, 
                    b.id, 
                    b.title, 
                    b.author, 
                    b.quantity, 
                    b.bookUpdated, 
                    b.bookIdentify 
                FROM 
                    transactions t 
                    INNER JOIN td_book b ON t.book_id = b.id 
                    WHERE  t.transaction_type = 'approved'
                    ";
            if(isset($_SESSION['role_id']) && $_SESSION['role_id'] == 2){
                $sql .= " AND t.user_id = " . $_SESSION['id'] . " ";
            }

        if (!empty($searchQuery)) {
            $sql .= "AND b.title LIKE '%$searchQuery%' OR b.author LIKE '%$searchQuery%' ";
        }

        // Add pagination limit and offset
        $limit = $itemsPerPage;
        $offset = ($page - 1) * $itemsPerPage;
        $sql .= "ORDER BY t.transaction_date DESC LIMIT $limit OFFSET $offset";

        // Execute SQL query and fetch results
        $results = $this->db->query($sql)->fetchAll(PDO::FETCH_ASSOC);


        // Return books and pagination data as an array
        return $results;
    }

    public function countTransactions()
    {
        $sql = "SELECT COUNT(*) FROM transactions WHERE  transaction_type = 'approved'";
        if(isset($_SESSION['role_id']) && $_SESSION['role_id'] == 2){
            $sql .= " AND user_id = " . $_SESSION['id'] . " ";
        }
        $count = $this->db->query($sql)->fetchColumn();
        return $count;
    }

    public function countBorrowedByUser($user_id){
        $transaction_type = 'approved';
        $sql = "SELECT COUNT(*) AS borrow_count FROM transactions WHERE user_id = :user_id AND transaction_type = :transaction_type";
        $stmt = $this->db->prepare($sql);
        $stmt->execute(['user_id' => $user_id, 'transaction_type' => $transaction_type]);
        $result = $stmt->fetch(PDO::FETCH_ASSOC);
        $borrow_count = $result['borrow_count'];
        return $borrow_count;
      }
    
    
}
