<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <link rel="icon" type="image/png" href="<?= ASSETS ?>/favicon.png">
  <?php if (isset($params['meta'])) { ?>
    <title><?= $params['meta']['title'] ?></title>
    <meta name="description" content="<?= $params['meta']['description'] ?>">
  <?php } ?>
  <link rel="stylesheet" href="<?= ASSETS ?>/style.css">
  <link rel="stylesheet" href="https://unicons.iconscout.com/release/v2.1.6/css/unicons.css">
  <script src="https://code.jquery.com/jquery-3.6.3.min.js" integrity="sha256-pvPw+upLPUjgMXY0G+8O0xUf+/Im1MZjXxxgOcBQBXU=" crossorigin="anonymous"></script>
  <script>
    $(document).ready(function() {
      $('.action-menu .dots').click(function(e) {
        e.stopPropagation(); // Prevent document click event from closing menu

        // Close all other menus
        $('.action-menu.active').not($(this).parent()).removeClass('active');

        // Toggle the current menu
        $(this).parent().toggleClass('active');
      });

      $(document).click(function(e) {
        // Close all menus
        if (!$('.action-menu').is(e.target) && $('.action-menu').has(e.target).length === 0) {
          $('.action-menu.active').removeClass('active');
        }
      });
    });
  </script>

  <style>
    .notification-circle {
      width: 18px;
    height: 18px;
    border-radius: 50%;
    background-color: #d9d9d9;
    color: black;
    font-size: 10px;
    text-align: center;
    line-height: 20px;
    right: 55px;
    position: absolute;
    margin: -9px -7px;
}
.batch{
  width: 10px;
  position: absolute;
  bottom: 10px;
  left: 26px;
  z-index: 10;
}
  </style>
</head>

<body>
  <main>

  <?php 
  
  ?>
    <?php if (isset($_SESSION['id'])) : ?>
      <?php 
              $users = $this->model('AuthModel');
              $countIssueRequest = $users->countIssueRequest();
              $user = $users->getUser($_SESSION['id']);
              $userRole = ($_SESSION['role_id'] == 1) ? 'admin' : 'user';


            
            ?>
      <div class="left-panel">
        <!-- left panel content here -->
        <div style="padding:1rem;color: white;">
          <h3>
            Library Mangement System
          </h3>
        </div>
 <nav class="vertical-menu">
          
        <?php if($_SESSION['role_id']==2):?>
          <a href="<?= ROOT ?>" class="<?= ($_SERVER['REQUEST_URI'] == '/lms/') ? 'active' : '' ?>"><i class="uil uil-create-dashboard"></i>Dashboard</a>
          <a href="<?= ROOT ?>/borrow-books/" class="<?= ($_SERVER['REQUEST_URI'] == '/lms/borrowed-books/') ? 'active' : '' ?>"><i class="uil uil-books"></i>Borrowed Books</a>
          <a href="<?= ROOT ?>/request-sent/" class="<?= ($_SERVER['REQUEST_URI'] == '/lms/request-sent/') ? 'active' : '' ?>"><i class="uil uil-clipboard-alt"></i> Request Sent</a>
         <a href="<?= ROOT ?>/overdue-books/" class="<?= ($_SERVER['REQUEST_URI'] == '/lms/overdue-books/') ? 'active' : '' ?>"><i class="uil uil-book"></i>Overdue Books</a>
        <?php endif;?>

        <?php if($_SESSION['role_id']==1):?>
          <a href="<?= ROOT ?>" class="<?= ($_SERVER['REQUEST_URI'] == '/lms/') ? 'active' : '' ?>"><i class="uil uil-create-dashboard"></i>Dashboard</a>
          <a href="<?= ROOT ?>/books/" class="<?= ($_SERVER['REQUEST_URI'] == '/lms/books/' || strpos($_SERVER['REQUEST_URI'], '/lms/books/') === 0) ? 'active' : '' ?>"><i class="uil uil-book-open"></i>Books</a>
          <a href="<?= ROOT ?>/borrow-books/" class="<?= ($_SERVER['REQUEST_URI'] == '/lms/borrowed-books/') ? 'active' : '' ?>"><i class="uil uil-books"></i>Borrowed Books</a>

          <a style="position:relative;" href="<?= ROOT ?>/issue-request/" class="<?= ($_SERVER['REQUEST_URI'] == '/lms/issue-request/') ? 'active' : '' ?>">
          <div class="notification-circle"><?=($countIssueRequest -4)?></div>
          <i class="uil uil-clipboard-alt"></i><img class="batch" src="<?=ASSETS?>/img/icons/batch.svg" alt="">Issue Request</a> 
          <a href="<?= ROOT ?>/overdue-books/" class="<?= ($_SERVER['REQUEST_URI'] == '/lms/overdue-books/') ? 'active' : '' ?>"><i class="uil uil-book"></i>Overdue Books</a>
          <a href="<?= ROOT ?>/users/" class="<?= ($_SERVER['REQUEST_URI'] == '/lms/users/') ? 'active' : '' ?>"><i class="uil uil-user-circle"></i>Users</a>
          <?php endif;?>

</nav>

        <nav class="vertical-bottom">
          <a href="<?= ROOT ?>/logout"> <i class="uil uil-sign-out-alt"></i>Logout</a>
        </nav>
      </div>

      <div class="right-panel">
        <!-- main content here -->
        <header>
          <div class="">
            <b>Hello, <?=$user['first_name']?></b>
            <p class="user_i"><?php date_default_timezone_set('America/New_York'); echo date('F j, Y l g.i A');?></p>
          </div>
          <div class="user">
            <div style="padding: 0 1rem;">

              <b><?=$user['first_name']?></b>
              <p class="user_i"> <?= $userRole ?></p>
            </div>
            <div class="profile-image"><?=$firstLetter = substr($user['first_name'], 0, 1);?></div>
          </div>

        </header>
      <?php endif; ?>
      {{content}}
      <?php if (isset($_SESSION['id'])) : ?>
      </div>
    <?php endif; ?>
    <main>
</body>

</html>