<div class="search-container">
    <form class="search-form" action="<?= ROOT ?>/" method="get">
        <input type="text" name="search" placeholder="Search book by title">
        <button type="button" class="gradient-btn">Search</button>

    </form>

</div>
<section class="books-container">
    <div class="books-category category-active">All</div>
    <div class="books-category">Science Fiction</div>
    <div class="books-category">Horror</div>
    <div class="books-category">Literature</div>
    <div class="books-category">Love Stories</div>
    <div class="books-category">Politics</div>
</section>

<section class="book-container" style="display: flex;flex-wrap: wrap;">


    <?php
    $search = isset($_GET['search']) ? $_GET['search'] : '';
    $booksModel = $this->model('booksModel');
    $searchColumns = array(
        0 => 'id',
        1 => 'title',
        2 => 'author',
        3 => 'quantity',
        4 => 'bookUpdated',
        5 => 'bookIdentify',
    );
    $totalRecords = $booksModel->countAll($search, $searchColumns);
    $page = isset($_GET['page']) ? (int)$_GET['page'] : 1;
    $pagination = new Pagination($totalRecords, $page, 10);
    $data = $booksModel->displayAllSearch($search, $searchColumns, $pagination->getOffset(), $pagination->getLimit());
    $params['books'] = $data;

    if ($totalRecords > $pagination->getLimit()) {
        $params['pagination'] =  $pagination->render();
    } else {
        $params['pagination'] = '';
    }

    ?>
    <?php if (count($params['books']) > 0) : ?>



        <?php foreach ($params['books'] as $key => $books) : ?>

            <div class="book-area" style="width:18%; box-sizing: border-box; padding: 0.5rem; margin:0.5rem;background: white;border-radius: 0.5rem;">
                <img src="<?=$books['cover']?>" style="width:100%;height: 170px;">
                <p style="color: #2088af;font-size: 13px;">New Edition</p>
                <div style="display: flex;justify-content: space-between;font-weight: bold;">
                    <p><?= $books['title'] ?></p>
                    <p>$15</p>
                </div>
                <p style="color: #333;font-size: 13px;margin-bottom:2px;"><?= $books['author'] ?></p>
                 <button data-book-id="<?= $books['id'] ?>" class="gradient-btn borrow-button" style="width:100%;">Sent borrow request</button>
            </div>


        <?php endforeach; ?>
</section>
<div class="pagination-container">
    <?= $params["pagination"] ?>
</div>
<?php else : ?>
    <p>No Record to Display.</p>
<?php endif; ?>

<script>
$(document).on('click', '.borrow-button', function(e) {
    e.preventDefault();
    var button = $(this); // store a reference to the button
    var bookId = button.data('book-id');
    var dataString = 'book_id=' + bookId;
    $.ajax({
        url: '<?=ROOT?>/borrow-book/build',
        type: 'POST',
        data: dataString,
        success: function(response) {
            button.css('color', 'red');
            button.text('Borrow request Sent.');
        },
        error: function(xhr, status, error) {
            alert('AJAX error: ' + error);
        }
    });
});

</script>