<?php
session_start();
include "../app/init.php";

$app = new app(dirname(__DIR__));
// Define routes here and start app run
$app->router->get('', [HomeController::class, 'index']);
$app->router->get('/login', [AuthController::class, 'login']);
$app->router->post('/login', [AuthController::class, 'login']);

$app->router->get('/register', [AuthController::class, 'register']);
$app->router->post('/register', [AuthController::class, 'register']);

$app->router->get('/forget-password', [AuthController::class, 'forget']);
$app->router->get('/logout', [AuthController::class, 'logout']);


// books of routes
$app->router->get('/books', [BooksController::class, 'booksIndex']);
$app->router->get('/books/build', [BooksController::class, 'booksBuild']);
$app->router->post('/books/build', [BooksController::class, 'booksRecord']);
$app->router->get('/books/{booksIdentify}/destroy', [BooksController::class, 'booksDestroy']);
$app->router->get('/books/{booksIdentify}/modify', [BooksController::class, 'booksModify']);
$app->router->post('/books/{booksIdentify}/modify', [BooksController::class, 'booksEdit']);
$app->router->get('/books/{booksIdentify}', [BooksController::class, 'booksDisplay']);


$app->router->get('/borrow-books', [BorrowBookController::class, 'index']);
$app->router->post('/borrow-book/build', [BorrowBookController::class, 'record']);

$app->router->get('/issue-request', [IssueRequestController::class, 'index']);
$app->router->post('/issue-request/build', [IssueRequestController::class, 'record']);
$app->router->get('/request-sent', [IssueRequestController::class, 'listSentRequest']);
$app->router->get('/request-sent/view-receipt/{id}', [IssueRequestController::class, 'viewReceipt']);


$app->router->get('/overdue-books', [OverdueBooksController::class, 'index']);

$app->router->get('/users', [UsersController::class, 'usersIndex']);
$app->router->get('/users/build', [UsersController::class, 'usersBuild']);
$app->router->post('/users/build', [UsersController::class, 'usersRecord']);
$app->router->get('/users/{usersIdentify}/modify', [UsersController::class, 'usersModify']);
$app->router->post('/users/{usersIdentify}/modify', [UsersController::class, 'usersEdit']);


$app->run();